/*
Licensed Materials - Property of IBM

"Restricted Materials of IBM"

CA0D

(c) Copyright IBM Corp. 2013 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or
disclosure restricted by GSA ADP Schedule Contract with
IBM Corp. 
*/


// Worklight comes with the jQuery 1.8.1 framework bundled inside. If you do not want to use it, please comment out the line below.
window.$ = window.jQuery = WLJQ;


//---------------------------- Set up push notifications -------------------------------
WL.Client.Push.onReadyToSubscribe = function(){


	WL.Client.Push.registerEventSourceCallback(
			"MotorClaim", 
			"ClaimNotification", 
			"MotorClaimNotification", 
			pushNotificationReceived);
			
			subscribeButtonClicked();

		};

		
			


// --------------------------------- Subscribe ------------------------------------
function subscribeButtonClicked(){
	WL.Client.Push.subscribe("MotorClaim", {
		onSuccess: pushSubscribe_Callback,
		onFailure: pushSubscribe_CallbackFail
	});
}

function pushSubscribe_Callback(response){
	//alert("PushSubscribe_Callback invoked:"+response);
}

function pushSubscribe_CallbackFail(response){
	alert("Notification subscription failed:"+response+" : Retrying now");
	
}

//------------------------------- Unsubscribe ---------------------------------------
function unsubscribeButtonClicked(){
	WL.Client.Push.unsubscribe("MotorClaim", {
		onSuccess: pushUnsubscribe_Callback,
		onFailure: pushUnsubscribe_Callback
	});
}

function pushUnsubscribe_Callback(response){
	//alert("pushUnsubscribe_Callback invoked");
}

var payloadVal;
//------------------------------- Handle received notification ---------------------------------------
function pushNotificationReceived(props, payload){
//	alert("pushNotificationReceived invoked");
//	alert("props :: " + JSON.stringify(props));
//	alert("payload :: " + JSON.stringify(payload));
	try{
	busyIndicator.hide();
	}
	catch(e){
		
	}
	payloadVal = payload;
	inquireOtherCustomer(payload.c);

	
}

function inquireOtherCustomer(otherUsername){
	

	var invocationData = {
			adapter: "GENAPPInquire",
			procedure: "getCustomerDetails",
			parameters: [otherUsername]
	};
	
	
	
	WL.Client.invokeProcedure(invocationData, {
		onSuccess: getOtherCustomer_SuccessCallback,
		onFailure: getOtherCustomer_FailCallback
	});
	
}

var firstName;
var lastName;
function getOtherCustomer_SuccessCallback(response){

	firstName = response.invocationResult.LGICUS01OperationResponse.ca.ca_first_name;
	
	lastName =  response.invocationResult.LGICUS01OperationResponse.ca.ca_last_name;
	
	
	//use another motor inquiry here to populate claim details below
	
	var invocationData = {
			adapter : "GENAPPInquire",
			procedure : "getMotorPolicy",
			parameters : [ payloadVal.c,payloadVal.p ]
	};

	WL.Client.invokeProcedure(invocationData, {
			onSuccess : getOtherDriverMotor_SuccessCallback,
			onFailure : getOtherDriverMotor_FailCallback
	});


}


function getOtherDriverMotor_SuccessCallback(response){
	
	var cc = response.invocationResult.LGIPOL01OperationResponse.ca_m_cc;
	var make = response.invocationResult.LGIPOL01OperationResponse.ca_m_make;
	var model = response.invocationResult.LGIPOL01OperationResponse.ca_m_model;
	var colour = response.invocationResult.LGIPOL01OperationResponse.ca_m_colour;
	var reg = response.invocationResult.LGIPOL01OperationResponse.ca_m_regnumber;
	
		
	
populateClaim("claimAlert",firstName,lastName,make,model,reg,colour,payloadVal.c,payloadVal.p);
	
}

function getOtherDriverMotor_FailCallback(response){
	alert("getOtherDriver call fail for claim:"+response);
}


function getCarImage(carMake)
{
	
	return "images/Placeholder-image-128x96.png";
	
}

function getCarIconImage(carMake){
	
	
return "images/Placeholder-image-64x48.png";
	
}

function confirmClaimAlert(){
	require(["dojo/on","dijit/registry","dojox/mobile/View","dojox/mobile/ListItem","dojox/mobile/TabBar","dojox/mobile/Badge"], function(on,registry,View){
		
	
		registry.byId("confirmClaimAlert").hide(); 
		
		try{
		WL.Badge.setNumber(0);
		}
		catch(e){
			
		}
		$('#pendingClaim').show();
		$('#confirmClaim').hide();
		
/*		//tidy up all badges
		registry.byId("tabbarbutton3").set("badge",null);*/
		//remove a badge
		var tabbarClaim=registry.byId("tabbarbutton3");
		var badgeNo=(tabbarClaim.get("badge")==null)?0:tabbarClaim.get("badge");
		badgeNo=badgeNo-1;
		if(badgeNo>0)
			tabbarClaim.set("badge",badgeNo);
		else
			tabbarClaim.set("badge",null);
});
	}
function setupClaimDetailContent(val,firstName,lastName,customerNumber,reg,claimantCarPolNumber,colour,make,model){
			try{
	 var unique1 = guid();
     var unique2 = guid();
     var unique3 = guid();
     var unique4 = guid();
     var unique5 = guid();
     var unique6 = guid();
     var unique7 = guid();
	require(["dojo/on",
	         "dojo/ready",
	         "dojo/dom-construct",
	         "dojo/_base/window",
	         "dojox/mobile/ScrollableView",
	         "dojox/mobile/Heading",
	         "dojox/mobile/ToolBarButton",
	         "dojox/mobile/ContentPane","dojo/domReady!","dijit/registry","dojo"
	     ], function(on,ready, domConstruct, win, ScrollableView, Heading, ToolBarButton, ContentPane,DomReady,registry,dojo){
	         ready(function(){
	        	 
	           
	             var claimsViewDetail = new ScrollableView({
	                 id:val,
	                 class:"viewBackground"
	             });
	             dojo.place(claimsViewDetail.domNode, "mainTabBar","before");
	            
	             var heading = new Heading({
	                 label:"Policy Claims",
	                 fixed:"top",
	                class:"appHeader"
	             });
	             var b = new ToolBarButton({
	                 arrow:"left",
	                 moveTo:"claimsView",
	                 transition:"reveal",
	                 transitionDir:"-1",
	                 label:"Claims"
	             });
	            
	             var html = '<p class="smallHeaderStyleWhite" style="margin-left: 5px;">A claim has been made against your car insurance.</p>  <table id="claimantDetails" class="policyTable"><tr><td class="tdType smallHeaderStyle">Claimant</td><td id="claimantName'+unique1+'" class="paragraphStyle">'+firstName+" "+lastName+'</td></tr><tr class="alt"><td class="tdType smallHeaderStyle">Customer number</td><td id="claimantCustomerNumber'+unique2+'" class="paragraphStyle">'+customerNumber+'</td></tr><tr><td class="tdType smallHeaderStyle">Motor policy number</td><td id="claimantMotorPolicyNumber'+unique3+'" class="paragraphStyle">'+claimantCarPolNumber+'</td></tr><tr class="alt"><td class="tdType smallHeaderStyle">License plate</td><td id="claimantLicense'+unique4+'" class="paragraphStyle">'+reg+'</td></tr><tr><td class="tdType smallHeaderStyle">Make / Model</td><td id="claimantModel'+unique5+'" class="paragraphStyle">'+colour+" "+make+" "+"model"+'</td></tr></table><button id="'+unique6+'" data-dojo-type="dojox/mobile/Button" style="margin-left: 5px;">Confirm claim details</button><br><div id="'+unique7+'" style="display: none;"><p class="paragraphStyleWhite" style="margin-left: 5px;">Your claim is pending. We will be in contact shortly.</p></div>';
	             
	             
	             heading.addChild(b);
	             claimsViewDetail.addFixedBar(heading);
	             var cont = new ContentPane({
	                 innerHTML : html
	             });
	             
	             
	             
	             claimsViewDetail.addChild(cont);
	             
	             
	             
	            
	             claimsViewDetail.startup();
	             var confirmClaimButton = document.getElementById(unique6);
	     		
	     		on(confirmClaimButton, "click", function(e){
	     			
	     			registry.byId("confirmClaimAlert").show();
	     			$('#'+unique7).show();
	     		});
	            
	         });
	     });			
			
			}
			catch(e){
				alert("Something wrong in setupClaimContent:"+e+" err message:"+e.message);
			
			   
			}
		
}
function populateClaim(id, firstName, lastName, make, model, reg, colour,
		customerNumber, claimantCarPolNumber) {
	
	var unique = guid();
	
	
	//alert("id"+id+" first name:"+firstName+" reg:"+reg);
	require(["dojo/on","dijit/registry","dojox/mobile/View","dojox/mobile/ListItem","dojox/mobile/TabBar","dojox/mobile/Badge"], function(on,registry,View){
		try{
			if(busyIndicator!=null)busyIndicator.hide();
	
		registry.byId(id).show(); 
	
		var tabbarClaim=registry.byId("tabbarbutton3");
		if(tabbarClaim.get("badge")==null)
			tabbarClaim.set("badge","1");
		else
			tabbarClaim.set("badge",parseInt(tabbarClaim.get("badge"))+1);			
		
		var listWidget = registry.byId("claimsList");
		var unique2 = guid();

		var newH4 = document.createElement("h4");
			newH4.className = "boxTitle smallHeaderStyle";
			newH4.id = "id" + unique2;
			var text = document.createTextNode("Other party:" + firstName + " "
					+ lastName);
        newH4.appendChild(text);

        var unique3 = guid();
        var newP = document.createElement("p");
        newP.className = "boxDescription paragraphStyle";
			newP.id = "id" + unique3;
			var text2 = document.createTextNode(make + " " + model);
        newP.appendChild(text2);
			newP.appendChild(document.createElement("br"));
			var text3 = document.createTextNode("License plate:" + reg);
			newP.appendChild(text3);
			
			 var unique4 = guid();
			setupClaimDetailContent(unique4,firstName,lastName,customerNumber,reg,claimantCarPolNumber,colour,make,model);
			
			var listItem = new dojox.mobile.ListItem({
				id : "claim" + unique,
				moveTo : unique4,
				transition : "cover",
				variableHeight : true,
				icon:getCarImage(make)
		});
			listItem.set("class","claimList");
		listItem.containerNode.appendChild(newH4);
		listItem.containerNode.appendChild(newP); 
		
		listItem.startup();
		listWidget.addChild(listItem);
		//listWidget.startup();
		
		
		
		
		
		//var handle = on(listItem,"click",);
		}
		catch(e){
			alert("went wrong:"+e);
		}
	});
}


function moveToClaims(option,ID){
	if(option==0){
		require(["dojo/on","dijit/registry","dojox/mobile/View"], function(on,registry,View){
			 
			registry.byId(ID).hide(); 
			
			
		});
	}
	else{
		require(["dojo/on","dijit/registry","dojox/mobile/View","dojox/mobile/TabBarButton"], function(on,registry,view){
			
		
		
		
		registry.byId("home").hide();
		registry.byId("yourAccount").hide();
		registry.byId("carView").hide();
		registry.byId("carBuy").hide();
		registry.byId("carBuySpecific").hide();
		registry.byId("carClaim").hide();
		registry.byId("homeView").hide();
		registry.byId("homeBuy").hide();
		registry.byId("homeClaim").hide();
		registry.byId("editDetailsView").hide();
		registry.byId("endowmentView").hide();
		registry.byId("endowmentBuy").hide();
		registry.byId("endowmentClaim").hide();
		registry.byId("claimsView").hide();
		registry.byId("settingsView").hide();
		registry.byId("claimsView").hide();
		registry.byId(ID).hide();
		registry.byId("tabbarbutton3").set("selected", true);
		registry.byId("claimsView").show();
		
	
		});
	}
	
}




function getOtherCustomer_FailCallback(response){
alert("getOtherCustomer fail::"+response);	
}