/*
Licensed Materials - Property of IBM

"Restricted Materials of IBM"

CA0D

(c) Copyright IBM Corp. 2013 All Rights Reserved.

US Government Users Restricted Rights - Use, duplication or
disclosure restricted by GSA ADP Schedule Contract with
IBM Corp. 
*/
/// /////////////////////

// Challenge Handler

// /////////////////////


var customAuthenticatorRealmChallengeHandler = WL.Client.createChallengeHandler("CustomAuthenticatorRealm");
var username = "";
var mainProgressIndicator;

customAuthenticatorRealmChallengeHandler.isCustomResponse = function(response) {

    if (!response || !response.responseJSON) {
        return false;
    }

    if (response.responseJSON.authStatus) 
    	return true;
    else 
    	return false;
};

function hideMainProgressBox(){
	
	require(["dijit/registry","dojox/mobile/ProgressIndicator","dojox/mobile","dojox/mobile/parser","dojox/mobile/SimpleDialog"], function(registry,ProgressIndicator){
	mainProgressIndicator.stop();
	registry.byId("mainLoadingDialog").hide();
});
}

function showLoadingInfo(infoString){
	
	require(["dojo/on","dijit/registry","dojox/mobile","dojox/mobile/parser","dojox/mobile/SimpleDialog"], function(on,registry){
	$("#mainLoadingInfoText").text(infoString);
	registry.byId("mainLoadingInfoDialog").show();
	
	var buttonLoadingInfo = document.getElementById("mainLoadingButton");
	on(buttonLoadingInfo, "click", function(e){
		  registry.byId("mainLoadingInfoDialog").hide(); 
	  });

});
}





customAuthenticatorRealmChallengeHandler.handleChallenge = function(response){
	var authStatus = response.responseJSON.authStatus;
	username = response.responseJSON.username;
	if (authStatus == "required"){
		
		
		require(["dijit/registry"], function(registry){

			registry.byId("mainTabBar").domNode.style.display= "none";
			registry.byId("loginForm").resize();
			registry.byId("loginForm").show();
			
			
		});
		
		$('#passwordInputField').val('');
		//enable the login button as we are now being challenged and our authenticator is initialised
		$('#loginButton').attr('disabled',false);
		
		
        if (response.responseJSON.errorMessage){
        	hideMainProgressBox();
        	showLoadingInfo(response.responseJSON.errorMessage);
        }
	} else if (authStatus == "complete"){
	
		
		var mainContainer=document.getElementById("mainLoadingContainer");
		var authComplete = document.createElement("p");
		authComplete.innerHTML = "Auth Complete Stage 1";
		mainContainer.appendChild(authComplete);
	
		if(customAuthenticatorRealmChallengeHandler==null){
			customAuthenticatorRealmChallengeHandler = WL.Client.createChallengeHandler("CustomAuthenticatorRealm");
		}

		customAuthenticatorRealmChallengeHandler.submitSuccess();
		$('#loginButton').attr('disabled',true);

		
		
		//subscribeButtonClicked();
		

		$('#SubscribeButton').bind('click', subscribeButtonClicked);
		
		$('#UnsubscribeButton').bind('click', unsubscribeButtonClicked);
		
		authComplete.innerHTML = "";
		authComplete.innerHTML = "Getting customer details";
		inquireCustomer();
		
		
	}
	else{
		var mainContainer=document.getElementById("mainLoadingContainer");
		var authComplete = document.createElement("p");
		authComplete.innerHTML = "Login error:"+authStatus+":"+JSON.stringify(response.responseJSON);
		mainContainer.appendChild(authComplete);
	}
};


customAuthenticatorRealmChallengeHandler.submitLoginFormCallback = function(response) {
    var isLoginFormResponse = customAuthenticatorRealmChallengeHandler.isCustomResponse(response);
    if (isLoginFormResponse){
    	customAuthenticatorRealmChallengeHandler.handleChallenge(response);
    } 
};
 
$('#loginButton').bind('click', function () {
    var reqURL = '/j_security_check';
    var options = {};
    var hash = CryptoJS.MD5($('#passwordInputField').val());
    hash = hash.toString();
   
    options.parameters = {
        username : $('#usernameInputField').val(),
        password : hash.toString()
    };
    
    require(["dojox/mobile/ProgressIndicator","dojo/on","dijit/registry","dojox/mobile/View","dojox/mobile/Switch"], function(ProgressIndicator,on,registry,View){
    	
    	
    	 var widget = registry.byId("rememberMe");
    	 var val = widget.get("value"); // "on" or "off" can be set
    	  
    	
    	    if(typeof(Storage)!=="undefined")
    	    {
    	    	if(val=="on"){
    	    		localStorage.username=$('#usernameInputField').val();	
    	    	}
    	    	else{
    	    		localStorage.username=null;
    	    	}
    	    	
    	    	localStorage.rememberMe=val;
    	    }
    	  else
    	    {
    	  alert("Sorry - it appears your phone has not HTML 5 compliant local storage. The 'Remember me' option will not work.");
    	    }
  
   
    
   
  	registry.byId("mainLoadingDialog").show();
    	mainProgressIndicator=ProgressIndicator.getInstance();
    	var mainContainer=document.getElementById("mainLoadingContainer");
    	mainContainer.appendChild(mainProgressIndicator.domNode);
    	mainProgressIndicator.start();
    });
    options.headers = {};
    customAuthenticatorRealmChallengeHandler.submitLoginForm(reqURL, options, customAuthenticatorRealmChallengeHandler.submitLoginFormCallback);

   
    });

$('#cancelButton').bind('click', function () {
	registry.byId("loginForm").show();
	customAuthenticatorRealmChallengeHandler.submitFailure();
});



