/**
 * http://www-01.ibm.com/support/docview.wss?uid=swg27038292
 * http://pic.dhe.ibm.com/infocenter/wrklight/v6r1m0/topic/com.ibm.worklight.installconfig.doc/admin/t_protecting_your_mobile_app_traffic_using_datapower.html
 */

var customResponseCounter=0;
var handleChallengeCounter=0;
var submitLoginFormCallbackCounter=0;
var submitSuccessCounter=0;

function showLoginScreen() {
	console.log('show login screen');
	$("#AppBody").hide();
	$("#AuthBody").show();
}

function showMainScreen() {
	$("#AuthBody").hide();
	$("#AppBody").show();
}

var mainProgressIndicator;
var username = "";
var authStatus="";
var lastRequestURL;
var myChallengeHandler = WL.Client.createChallengeHandler("WASLTPARealm");

myChallengeHandler.isCustomResponse = function(response) {
	console.log('START myChallengeHandler.isCustomResponse');
	customResponseCounter++;
	console.log('customResponseCounter: '+customResponseCounter);
	
	//An error DataPower login form has been returned
	var findError = response.responseText.search("DataPower Error");
	if(findError >= 0) {
		console.log(JSON.stringify('DataPower responseText: '+response.responseText));
		console.log('DataPower Error');
		return true;
	}
	
	//A Form login authentication failure occurred
	var findAuthError = response.responseText.search("authentication failure");
	if(findAuthError >= 0) {
		console.log(JSON.stringify('authfailure responseText: '+response.responseText));
		alert('Authentication failed');
		console.log('authentication Error');		
		return true;    
	}
	
	//A normal DataPower login form has been returned
	var findLoginForm = response.responseText.search("DataPower Form Login");
	if(findLoginForm >= 0) {
		console.log(JSON.stringify('Data Form responseText: '+response.responseText));
	  	console.log('DataPower Form Login');
	  	lastRequestURL = response.request.url;
    	return true;
	}
 
	//A normal Worklight login form has been returned
	//var findWLForm = response.responseText.search("Worklight Form Login");
	var findWLForm = response.responseText.search("Worklight Login");
	if(findWLForm >= 0) {
		console.log(JSON.stringify('WL login responseText: '+response.responseText));
		console.log('Worklight login.html');
		lastRequestURL = response.request.url;
		if(!submitSuccessCounter>=1){
    	return true;
		} else{
    	alert('This is a second login request, please contact administrator!');
    	console.log('Worklight is challenging after DataPower!');
    	//TODO: Validate error condition
    	//TD: need to clear cache & cookies on iOS simulator
    	return true;
    	}    
	}
	
	//An error Worklight login form has been returned
	var findErrorForm = response.responseText.search("Worklight Login Error");
	if(findErrorForm >= 0) {
		console.log('WL Error responseText: '+JSON.stringify(response.responseText));
		console.log('Worklight LoginError.html');
		lastRequestURL = response.request.url;
		return true;
	}
  	
	//[Log] "{\"errorCode\":\"UNEXPECTED_ERROR\",\"errorMsg\":\"Missing Json Query Parameter adapter\"}"
	//Gateway detected an error during processing of service request
	//TODO: define rules for custom responses above
	
	//This response is a Worklight server response, handle it normally
  	console.log('normal WL Server response:');
  	console.log(JSON.stringify(response.responseText));
    return false;
    
};

function hideMainProgressBox(){
	
	require(["dijit/registry","dojox/mobile/ProgressIndicator","dojox/mobile","dojox/mobile/parser","dojox/mobile/SimpleDialog"], function(registry,ProgressIndicator){
	mainProgressIndicator.stop();
	registry.byId("mainLoadingDialog").hide();
});
}

function showLoadingInfo(infoString){
	
	require(["dojo/on","dijit/registry","dojox/mobile","dojox/mobile/parser","dojox/mobile/SimpleDialog"], function(on,registry){
	$("#mainLoadingInfoText").text(infoString);
	registry.byId("mainLoadingInfoDialog").show();
	
	var buttonLoadingInfo = document.getElementById("mainLoadingButton");
	on(buttonLoadingInfo, "click", function(e){
		  registry.byId("mainLoadingInfoDialog").hide(); 
	  });

	});
}

myChallengeHandler.handleChallenge = function(response) {
	console.log('START myChallengeHandler.handleChallenge');
	handleChallengeCounter++;
	console.log('handleChallengeCounter: '+handleChallengeCounter);
	//if (response.responseJSON==null) {
	if (!response.responseJSON) {		
		console.log('myChallengeHandler.handleChallenge(response): '+JSON.stringify(response));				
		if(handleChallengeCounter>1){
			alert('Please make sure you entered a valid credential');
			//TODO: 'require' is undefined, causing the rest of function to not execute
			/*require(["dojox/mobile/ProgressIndicator","dojo/on","dijit/registry","dojox/mobile/View","dojox/mobile/Switch"], function(ProgressIndicator,on,registry,View){
				console.log('stopping mainLoadingDialog'); 
				registry.byId("mainLoadingDialog").hide();
			   	 mainProgressIndicator=ProgressIndicator.getInstance();
			   	 var mainContainer=document.getElementById("mainLoadingContainer");
			   	 mainContainer.appendChild(mainProgressIndicator.domNode);
			   	 console.log('stopping mainProgressIndicator');
			   	 mainProgressIndicator.stop();
			});*/			   	 
		}
		console.log('response.responseJSON is empty, require login');
		
		//TODO: Need to add a check to see if dialog exists
		/*console.log('stopping mainLoadingDialog');
		hideMainProgressBox();*/	   	 
		
		showLoginScreen();
		  $('#loginButton').attr('disabled',false);
		  console.log('loginButton enabled');
	} else{
		authStatus = response.responseJSON.WASLTPARealm.isUserAuthenticated;
		console.log('response.responseJSON.WASLTPARealm: '+JSON.stringify(response.responseJSON.WASLTPARealm));
		
		//authStatus is returned explicitly from CustomAuthenticator: , not the same in WASLTPA authenticator
		//username = response.responseJSON.username;
		username = response.responseJSON.WASLTPARealm.userId;
		console.log('username = '+username);
	}
	
	if (authStatus===1){
		console.log('isUserAuthenticated ==='+authStatus);
		
		/*//from CustomerAuthenticatorRealChallengeHandler
		var mainContainer=document.getElementById("mainLoadingContainer");
		var authComplete = document.createElement("p");
		authComplete.innerHTML = "Auth Complete Stage 1";
		mainContainer.appendChild(authComplete);*/
		
		console.log('authentication completed, before subscribing to push');
		subscribeButtonClicked();
		$('#SubscribeButton').bind('click', subscribeButtonClicked);
		$('#UnsubscribeButton').bind('click', unsubscribeButtonClicked);
		console.log('after subscribing to push');		
		
		//Move to wlEnvInit: Success
		/*console.log('before inquireCustomer');
		inquireCustomer();
		console.log('after inquireCustomer');*/
		//return;
	}
	//TODO: implement authentication failure
	if (authStatus!=1) {
		console.log('isUserAuthenticated == '+authStatus);
	}
	
	/*if(!something){
		console.log('handleChallenge condition does not exisit!');
		return;
	}*/
	
	console.log('END myChallengeHandler.handleChallenge');
};

myChallengeHandler.handleFailure = function(response) {
	console.log("myChallengeHandler.handleFailure");  
	console.log("Error during WL authentication.");
};

myChallengeHandler.submitLoginFormCallback = function(response) {
	console.log('START myChallengeHandler.submitLoginFormCallback');
	submitLoginFormCallbackCounter++;
	console.log('submitLoginFormCallbackCounter: '+submitLoginFormCallbackCounter);
	var isCustom = myChallengeHandler.isCustomResponse(response);
	
	//Login success, normal Worklight response.
	if (!isCustom) {		
		console.log('Triggering login');
		myChallengeHandler.submitSuccess();
		submitSuccessCounter++;
		
		//moved to wlEnvInit Success
		//inquireCustomer();		
    }
	
	//login failed
    else {    	
    	//TODO: evaluate handling challenge multiple time (loop?)
    	console.log('login failed: handle challenge');
        myChallengeHandler.handleChallenge(response);
    }
    console.log('END myChallengeHandler.submitLoginFormCallback');
};

//When the login button is pressed, submit a login form
$("#loginButton").click(function() {
	var reqURL = "/j_security_check";
	console.log('lastRequestURL '+lastRequestURL);
	console.log('button clicked, submitLoginForm');
	var options = {method: "POST"};
	options.parameters = {
	j_username: $("#usernameInputField").val(),
	j_password: $("#passwordInputField").val(),
	originalUrl : lastRequestURL,
	login: "Login"  	
	};

	//TODO: 'require' is undefined, causing the rest of function to not execute
	/*require(["dojox/mobile/ProgressIndicator","dojo/on","dijit/registry","dojox/mobile/View","dojox/mobile/Switch"], function(ProgressIndicator,on,registry,View){  	
  	
 	 var widget = registry.byId("rememberMe");
 	 var val = widget.get("value"); // "on" or "off" can be set
 	   	
 	    if(typeof(Storage)!=="undefined")
 	    {
 	    	if(val=="on"){
 	    		localStorage.username=$('#usernameInputField').val();	
 	    	}
 	    	else{
 	    		localStorage.username=null;
 	    	}
 	    	
 	    	localStorage.rememberMe=val;
 	    }
 	  else
 	    {
 	  alert("Sorry - it appears your phone has not HTML 5 compliant local storage. The 'Remember me' option will not work.");
 	    }

 	 console.log('starting mainLoadingDialog');
 	 registry.byId("mainLoadingDialog").show();
 	 mainProgressIndicator=ProgressIndicator.getInstance();
 	 var mainContainer=document.getElementById("mainLoadingContainer");
 	 mainContainer.appendChild(mainProgressIndicator.domNode);
 	 console.log('starting mainProgressIndicator');
 	 mainProgressIndicator.start();
 });
 */
	//TODO: add EOC implementation to store the username.val() using password.val() as the secret key
	//localStorage.username=$('#usernameInputField').val();
	
	options.headers = {};
  	myChallengeHandler.submitLoginForm(reqURL, options, myChallengeHandler.submitLoginFormCallback);
  	console.log('myChallengeHandler.submitLoginForm options:'+JSON.stringify(options)+ 'reqURL:'+reqURL);
});