//
//
//"Restricted Materials of IBM"
//
//CA0D
//
//(c) Copyright IBM Corp. 2013 All Rights Reserved.
//
//US Government Users Restricted Rights - Use, duplication or
//disclosure restricted by GSA ADP Schedule Contract with
//IBM Corp. 

package com.ibm.cics;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Logger;

import com.worklight.server.auth.api.MissingConfigurationOptionException;
import com.worklight.server.auth.api.UserIdentity;
import com.worklight.server.auth.api.WorkLightLoginModule;

public class MyCustomLoginModule implements WorkLightLoginModule {
	private static final Logger logger = Logger.getLogger(MyCustomLoginModule.class.getName());
 
	private String USERNAME;
	private String PASSWORD;


	private boolean connectDB2(String username,String password){
 
		String host = "example.com"; //hostname of the DB2 instance
		String port = "448"; //SVCEHOST of the DB2 instance
		String subsystem = "DB2SYSID"; //DB2 z/OS location name
		String DBUsername = "DBUSER"; //DB2 DB User
		String DBPassword = "dbpwd"; //DB2 DB User password
		String Database = "GENAPP1"; //DB2 DB Database name
		  
		logger.severe("Inside Connect DB2");
		try{
 
			// Load the driver
			Class.forName("com.ibm.db2.jcc.DB2Driver");
			logger.severe("Got the DB2 Driver");

			Connection con = DriverManager.getConnection("jdbc:db2://"+host+":"+port+"/"+subsystem,
					DBUsername,DBPassword);
			logger.severe("**** Created a JDBC connection to the data source");

			// Create the Statement
			Statement   stmt = con.createStatement();                                           
			logger.severe("**** Created JDBC Statement object"); 
 
			// Execute a query and generate a ResultSet instance
			ResultSet rs = stmt.executeQuery("SELECT CUSTOMERPASS FROM "+Database+".CUSTOMER_SECURE WHERE CUSTOMERNUMBER="+username+";");                   
			logger.severe("**** Created JDBC ResultSet object");
			String empNo = "";
			// Print all of the employee numbers to standard output device
			while (rs.next()) {
				empNo = rs.getString(1);
				logger.severe("Password is:"+empNo+" Password sent was:"+password);
				if(empNo.equals(password))return true;

				logger.info("Row = " + empNo);
			}
			logger.info("**** Fetched all rows from JDBC ResultSet");
			// Close the ResultSet
			rs.close();
			logger.info("**** Closed JDBC ResultSet");

			// Close the Statement
			stmt.close();
			System.out.println("**** Closed JDBC Statement");

			// Connection must be on a unit-of-work boundary to allow close
			con.commit();
			logger.info( "**** Transaction committed" );

			// Close the connection
			con.close();                                                            
			logger.info("**** Disconnected from data source");

			logger.info("**** JDBC Exit from class EzJava - no errors");

		}  

		catch (ClassNotFoundException e)
		{
			logger.severe("Could not load JDBC driver");
			logger.severe("Exception: " + e);
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			logger.severe(e.getMessage());
		}
		return false;



	}
	public void init(Map<String, String> options) throws MissingConfigurationOptionException {
		
	}

	public boolean login(Map<String, Object> authenticationData) {
		USERNAME = (String) authenticationData.get("username");
		PASSWORD = (String) authenticationData.get("password");
		//if(USERNAME!=null)return true;
		if( this.connectDB2(USERNAME,PASSWORD)){
			return true;
		}
		else 
			throw new RuntimeException("Invalid credentials - try again");
	} 


	public UserIdentity createIdenity(String loginModule) {
		HashMap<String, Object> customAttributes = new HashMap<String, Object>();
		customAttributes.put("AuthenticationDate", new Date());

		UserIdentity identity = new UserIdentity(loginModule, USERNAME, null, null, customAttributes, PASSWORD);
		return identity;
	}

	public void logout() {
		USERNAME = null;
		PASSWORD = null;
	}

	public void abort() {
		USERNAME = null;
		PASSWORD = null;
	}

	@Override
	public MyCustomLoginModule clone() throws CloneNotSupportedException {
		return (MyCustomLoginModule) super.clone();
	}



}
