//
//
//Licensed Materials - Property of IBM
//"Restricted Materials of IBM"
//
//CA0D
//
//(c) Copyright IBM Corp. 2013 All Rights Reserved.
//
//US Government Users Restricted Rights - Use, duplication or
//disclosure restricted by GSA ADP Schedule Contract with
//IBM Corp. 
//
package genapp.mobile.policy;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import com.ibm.cics.server.Channel;
import com.ibm.cics.server.Container;
import com.ibm.cics.server.Task;

public class DB2InquirePolicy
{
    public static void main(String[] args)
	{
    	
    	String DBName = "GENASA1";
    	Task t = Task.getTask();
		
		Channel policyInq = t.getChannel("policyInq");
		int retVal = 0;
		try {
			Container customer = policyInq.getContainer("customer");
			if(customer!=null) {
				try {
					Integer customerNo = Integer.parseInt(new String(customer.get()));
						
					Connection con = DriverManager.getConnection("jdbc:default:connection");
					Statement sqlStat = con.createStatement();
					ResultSet result = sqlStat.executeQuery("SELECT POLICYNUMBER,POLICYTYPE FROM "+DBName+".POLICY WHERE CUSTOMERNUMBER=" + customerNo.toString() + ";");
					
					int cnt = 0;
					while(result.next()==true)
					{
						
						Container policy = policyInq.createContainer("policy"+cnt);
						int policyNo = result.getInt("policyNumber"); 
						String policyType = result.getString("policyType");
						String total = policyNo + policyType;
						policy.put(total.getBytes());
						
						cnt++;
					}
					
				} catch (NumberFormatException nfe) {
					retVal = 3;
				} catch (SQLException se) {
					retVal = 7;
					t.out.println("Exception details: " + se.toString() + "\nSQLState: " + se.getSQLState());
					t.out.println("Error code: " + se.getErrorCode());
				}
			} else {
				retVal = 6;
				t.out.println("NO CUSTOMER CONTAINER");
			}
    	} catch (Exception e) {
			retVal=2;
			t.out.println("EXCEPTION IN DB2INQPOL - " + e.getMessage());
		}
    	
    	if(policyInq!=null) {
			try {
				Container returnCont = policyInq.createContainer("retVal");
				returnCont.put(Integer.toString(retVal));
			} catch (Exception e) {}
		}
    }
}
